package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.ForgetMeProxy

/**
 * Agent used to execute forget me.
 */
internal class ForgetMeAgent(private val proxy: ForgetMeProxy = ForgetMeProxy.default()): MethodCallAgent(nativeExceptionMessage) {
    companion object {
        /** Message to use in case of error during native call. */
        val nativeExceptionMessage = "Failed to execute ${AgentMethod.FORGET_ME.method}"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {
        proxy.forgetMe()

        return SuccessExecutionResponse.empty()
    }
}