package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.GetCurrentSessionReplayLinkProxy


/**
 * Agent used to execute to get the current session replay link.
 */
internal class GetCurrentSessionReplayLinkAgent(private val proxy: GetCurrentSessionReplayLinkProxy = GetCurrentSessionReplayLinkProxy.default()): MethodCallAgent(nativeExceptionMessage) {
    companion object {
        /** Message to use in case of error during native call. */
        const val nativeExceptionMessage = "Exception occurred when getting URL from native"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {
        val sessionReplayLink = proxy.getCurrentSessionReplayLink();

        return SuccessExecutionResponse(sessionReplayLink)
    }
}
