package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.GetStoredConfigProxy

internal class GetStoredConfigAgent(private val proxy: GetStoredConfigProxy = GetStoredConfigProxy.default()): MethodCallAgent(nativeExceptionMessage) {
    companion object {
        /** Message to use in case of error during native call. */
        const val nativeExceptionMessage = "Failed to get stored config"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {

        val config = proxy.getConfig()
        return SuccessExecutionResponse(config)
    }
}