package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.GetUserIdProxy


/**
 * Agent used to execute to get user id.
 */
internal class GetUserIdAgent(private val proxy: GetUserIdProxy = GetUserIdProxy.default()): MethodCallAgent(nativeExceptionMessage) {
    companion object {
        /** Message to use in case of error during native call. */
        const val nativeExceptionMessage = "Failed to get user id"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {
        val userId = proxy.getUserId();

        return SuccessExecutionResponse(userId)
    }
}
