package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.NotAvailableExecutionResponse


/**
 * [MethodCallAgent] used when there's no agent found to execute the method.
 */
internal class MissingMethodCallAgent(val method: String): MethodCallAgent(null) {
    override fun execute(data: ExecutionData): ExecutionResponse {
        return NotAvailableExecutionResponse(method = method, data = data)
    }
}