package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.FailedExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.FailedExecutionResponseReason
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.ResumeTrackingProxy


/**
 * Agent used to execute resume tracking.
 */
internal class ResumeTrackingAgent(private val proxy: ResumeTrackingProxy = ResumeTrackingProxy.default()): MethodCallAgent(nativeExceptionMessage) {
    companion object {
        /** Message to use in case of error during native call. */
        const val nativeExceptionMessage = "Failed to resume tracking"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {
        proxy.resumeTracking()

        return SuccessExecutionResponse.empty()
    }
}