package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.StopTrackingProxy


/**
 * Agent used to execute set URL Masking patterns.
 */
internal class StopTrackingAgent(private val proxy: StopTrackingProxy = StopTrackingProxy.default()): MethodCallAgent(nativeExceptionMessage) {
    companion object {
        /** Message to use in case of error during native call. */
        const val nativeExceptionMessage = "Failed to stop tracking"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {
        proxy.stopTracking()

        return SuccessExecutionResponse.empty()
    }
}