package com.contentsquare.flutter.infrastructure.core.method_call_executor.responses

import android.content.Context

/**
 * Reason of failure of an execution.
 */
internal enum class FailedExecutionResponseReason(val code: String) {
    /** An exception/error occurred in the native/sdk contentsquare. */
    NATIVE_EXCEPTION("NATIVE_EXCEPTION"),

    /** A required argument was not provided. */
    MISSING_ARGUMENT("MISSING_ARGUMENT"),

    /** An android [Context] was not provided. */
    NO_CONTEXT("NO_CONTEXT"),
}

/**
 * Response of an execution that failed.
 *
 * @see ExecutionResponse
 */
internal class FailedExecutionResponse(val reason: FailedExecutionResponseReason, val message: String?, val cause: Any?): ExecutionResponse()