package com.contentsquare.flutter.infrastructure.proxies

import com.contentsquare.android.Contentsquare
import com.contentsquare.flutter.infrastructure.bridges.ContentsquareSDKBridge

/**
 * Allows to call forget me of Contentsquare API.
 */
internal interface ForgetMeProxy {
    /**
     * Calls forget me of contentsquare API.
     */
    fun forgetMe()

    companion object Factory {
        /**
         * Creates a new instance of the default implementation of [ForgetMeProxy].
         */
        fun default(contentsquareSDK: ContentsquareSDKBridge = ContentsquareSDKBridge.getInstance()): ForgetMeProxy {
            return ForgetMeProxyImpl(contentsquareSDK = contentsquareSDK)
        }
    }
}

/**
 * An implementation of [ForgetMeProxy].
 *
 * @see ForgetMeProxy
 */
internal class ForgetMeProxyImpl(private val contentsquareSDK: ContentsquareSDKBridge) : ForgetMeProxy {

    override fun forgetMe() {
        contentsquareSDK.forgetMe()
    }
}