package com.contentsquare.flutter.infrastructure.proxies

import com.contentsquare.flutter.infrastructure.bridges.FlutterInterfaceBridge

//TODO: rename in FLUT-1212
internal interface  SendSessionReplayProtoDataListProxy {

    /**
     * Send the session replay proto data list to contentsquare Native SDK.
     *
     * @param protoDataList the list of sr events as a list of byteArrays.
     */
    fun send(protoDataList: List<ByteArray>)

    companion object Factory {
        /**
         * Creates a new instance of the default implementation of [SendSessionReplayProtoDataListProxy].
         */
        fun default(flutterInterfaceBridge: FlutterInterfaceBridge = FlutterInterfaceBridge.default()): SendSessionReplayProtoDataListProxy {
            return SendSessionReplayProtoDataListProxyImpl(flutterInterfaceBridge)
        }
    }
}

/**
 * An implementation of [SendSessionReplayProtoDataListProxy] that sends the session replay proto data list
 * to the ContentSquare Native SDK.
 *
 * @see SendSessionReplayProtoDataListProxy
 */

internal class SendSessionReplayProtoDataListProxyImpl(private val flutterInterfaceBridge: FlutterInterfaceBridge) : SendSessionReplayProtoDataListProxy {
    override fun send(protoDataList: List<ByteArray>) {
        flutterInterfaceBridge.sendSessionReplayProtoDataList(protoDataList)
    }
}