/// `MethodCallAgent` used to execute forget me
class ForgetMeAgent: MethodCallAgent {
    
    internal init(proxy: ForgetMeProxy = ForgetMeProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred during \(MethodCallAgentMethod.forgetMe.rawValue)"
    
    private let _proxy: ForgetMeProxy
    
    var nativeExceptionMessage: String? {
        return ForgetMeAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        
        try _proxy.forgetMe()
        
        return ExecutionResponse.succeed(result: nil)
    }
    
}
