/// `MethodCallAgent`used to execute to get the current session replay link.
class GetCurrentSessionReplayLinkAgent: MethodCallAgent {
    
    internal init(proxy: GetCurrentSessionReplayLinkProxy = GetCurrentSessionReplayLinkProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred when getting URL from native"
    
    private let _proxy: GetCurrentSessionReplayLinkProxy
    
    var nativeExceptionMessage: String? {
        return GetCurrentSessionReplayLinkAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        
        return ExecutionResponse.succeed(result: try _proxy.getCurrentSessionReplayLink())
    }
    
}
