/// `MethodCallAgent` used to execute to get the initial configuration.
class GetInitialConfigAgent: MethodCallAgent {
    
    internal init(proxy: GetStoredConfigProxy = GetStoredConfigProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred while getting the stored config"
    
    private let _proxy: GetStoredConfigProxy
    
    var nativeExceptionMessage: String? {
        return GetInitialConfigAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        return ExecutionResponse.succeed(result: try _proxy.getStoredConfig())
    }
    
}

