/// `MethodCallAgent` used to execute to get user id.
class GetUserIdAgent: MethodCallAgent {
    
    internal init(proxy: GetUserIdProxy = GetUserIdProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred while getting user ID"
    
    private let _proxy: GetUserIdProxy
    
    var nativeExceptionMessage: String? {
        return GetUserIdAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        return ExecutionResponse.succeed(result: try _proxy.getUserId())
    }
    
}
