/// `MethodCallAgent` used when there's no agent found to execute the method.
class MissingMethodCallAgent: MethodCallAgent {
    internal init(method: String) {
        self.method = method
    }
    
    let method: String
    
    var nativeExceptionMessage: String? {
        return nil
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        return ExecutionResponse.notAvailable(method: method, data: data)
    }
}
