/// `MethodCallAgent` used to execute OptIn.
class OptInAgent: MethodCallAgent {

    internal init(proxy: OptInProxy = OptInProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred during \(MethodCallAgentMethod.optIn.rawValue)"
    
    private let _proxy: OptInProxy
    
    var nativeExceptionMessage: String? {
        return OptInAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        
        try _proxy.optIn()
        
        return ExecutionResponse.succeed(result: nil)
    }
    
}
