/// `MethodCallAgent` used to execute OptOut.
class OptOutAgent: MethodCallAgent {
    
    internal init(proxy: OptOutProxy = OptOutProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred during \(MethodCallAgentMethod.optOut.rawValue)"
    
    private let _proxy: OptOutProxy
    
    var nativeExceptionMessage: String? {
        return OptOutAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        try _proxy.optOut()
        
        return ExecutionResponse.succeed(result: nil)
    }
    
}
