/// `MethodCallAgent` used to execute resume tracking.
class ResumeTrackingAgent: MethodCallAgent {
    
    internal init(proxy: ResumeTrackingProxy = ResumeTrackingProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred during \(MethodCallAgentMethod.resumeTracking.rawValue)"
    
    private let _proxy: ResumeTrackingProxy
    
    var nativeExceptionMessage: String? {
        return ResumeTrackingAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        
        try _proxy.resumeTracking()
        
        return ExecutionResponse.succeed(result: nil)
    }
    
}
