/// `MethodCallAgent` used to execute set URL Masking patterns.
class StopTrackingAgent: MethodCallAgent {
    
    internal init(proxy: StopTrackingProxy = StopTrackingProxyFactory.makeDefault()) {
        self._proxy = proxy
    }
    
    /// Message to use in case of error during native call.
    static let exceptionMessage = "Exception occurred during \(MethodCallAgentMethod.stopTracking.rawValue)"
    
    private let _proxy: StopTrackingProxy
    
    var nativeExceptionMessage: String? {
        return StopTrackingAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        
        try _proxy.stopTracking()
        
        return ExecutionResponse.succeed(result: nil)
    }
    
}
