class SwiftContentsquarePluginState {
    static let shared = SwiftContentsquarePluginState()

    private var sessionReplayEnabled: Bool = false
    private var sessionReplayContainerRecordingId: Int?
    private var csInAppEnabled: Bool = false
    private var apiErrorsEnabled: Bool = false
    private var crashReporterEnabled: Bool = false
    private var featureFlags: [[String: Any]] = []

    private init() {} // Private initializer

    func setSessionReplayState(_ enable: StateObject<Bool>) {
        sessionReplayEnabled = enable.value
    }
    
    func setsessionReplayContainerRecordingId(_ containerRecordingId: StateObject<Int>){
        sessionReplayContainerRecordingId = containerRecordingId.value
    }

    func setApiErrorsState(_ enable: StateObject<Bool>) {
        apiErrorsEnabled = enable.value
    }

    func setCrashReporterState(_ enable: StateObject<Bool>) {
        crashReporterEnabled = enable.value
    }

    func setFeatureFlagsState(_ featureFlagsState: StateObject<[[String: Any]]>) {
        featureFlags = featureFlagsState.value
    }
    
    func setCsInAppState(_ enable: StateObject<Bool>) {
        csInAppEnabled = enable.value
    }

    func getSessionReplayState() -> StateObject<Bool> {
        return StateObject(value: sessionReplayEnabled)
    }
    
    func getSessionReplayContainerRecordingId()-> StateObject<Int?> {
        return StateObject(value: sessionReplayContainerRecordingId)
    }

    func getApiErrorsState() -> StateObject<Bool> {
        return StateObject(value: apiErrorsEnabled)
    }

    func getCrashReporterState() -> StateObject<Bool> {
        return StateObject(value: crashReporterEnabled)
    }

    func getFeatureFlagsState() -> StateObject<[[String: Any]]> {
        return StateObject(value: featureFlags)
    }
    
    func getCsInAppState() -> StateObject<Bool> {
        return StateObject(value: csInAppEnabled)
    }
}

class StateObject<T> {
    var value: T

    init(value: T) {
        self.value = value
    }
}
