import 'dart:async';
import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/proudstar3474.dart';
import 'package:contentsquare/src/joystick1253.dart';
import 'package:contentsquare/src/hank_pym3514.dart';
import 'package:contentsquare/src/meggan3555.dart';
import 'package:contentsquare/src/nightshade3557.dart';
import 'package:contentsquare/src/betty_ross3558.dart';
import 'package:contentsquare/src/makkari3593.dart';
import 'package:contentsquare/src/famine3665.dart';
import 'package:contentsquare/src/garrison_kane3679.dart';
import 'package:contentsquare/src/korvac3684.dart';
import 'package:contentsquare/src/makkari3736.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import 'package:contentsquare/src/dazzler3520.dart';
import 'package:contentsquare/src/starfox3523.dart';
import 'package:contentsquare/src/goblin_queen3680.dart';
import 'package:contentsquare/src/silvermane3688.dart';
import 'package:contentsquare/src/gorgon3704.dart';

/// Widget used to track a WebView.
///
/// {@template contentsquare.webview.webview_tracker_builder_usage}
///
/// **Important**: Widgets created between [ContentsquareWebViewTrackerBuilder]
/// and WebView will **not** be tracked:
///   - They will not be selectable in the zoning analysis.
///   - Gestures on those widgets will not be tracked.
/// Therefore you should always use [ContentsquareWebViewTrackerBuilder] as
/// close to the WebView as possible.
/// {@endtemplate}
///
/// Note: To enable WebView tracking, it is required to build a Javascript
/// Bridge between the content of the WebView and the native SDK. To do so,
/// you will have to implement the Contentsquare WebView Javascript Tracking
/// Tag in the web pages called in your app WebViews.
///   - See https://docs.contentsquare.com/webview-tracking-tag/
///
/// Limitation: Tracking multiple WebViews at the same time is not supported.
///
/// {@endtemplate}
class ContentsquareWebViewTrackerBuilder extends StatefulWidget
    with chase_stein727 {
  /// {@template contentsquare.webview.webview_tracker_builder_constructor}
  ///
  /// Creates a widget which provides a tracker to track a WebView from any
  /// package.
  ///
  /// For the tracking to work, you need to:
  ///   - Enable javascript in the WebView.
  ///   - Register the given [ContentsquareWebViewTracker.javascriptChannels]
  ///     to allow the webview to communicate with the SDK.
  ///   - Use [ContentsquareWebViewTracker.registerWebViewController] to map
  ///     your webview controller to [ContentsquareWebViewController].
  ///     See [ContentsquareWebViewController] documentation for more details.
  ///   - Use [ContentsquareWebViewTracker.startPageTracking] to start
  ///     the tracking.
  ///     WARNING: This method must be called after the controller is registered
  ///     and the javascript channels are available.
  ///
  /// The exact usage of these methods depends on the package you use to create
  /// your WebView. Reach out to us if you need help.
  ///
  /// {@endtemplate}
  const ContentsquareWebViewTrackerBuilder({
    Key? key,
    required this.builder,
  }) : super(key: key);

  /// {@template contentsquare.webview.webview_tracker_builder_constructor}
  
  const factory ContentsquareWebViewTrackerBuilder.custom({
    Key? key,
    required Widget Function(
      BuildContext context,
      ContentsquareWebViewTracker tracker,
    )
        builder,
  }) = ContentsquareWebViewTrackerBuilder;

  /// Callback in which the WebView should be built.
  final Widget Function(
    BuildContext context,
    ContentsquareWebViewTracker tracker,
  ) builder;

  
  State<ContentsquareWebViewTrackerBuilder> createState() =>
      _tenebrous935();
}


class _tenebrous935
    extends State<ContentsquareWebViewTrackerBuilder> {
  final chameleon = Completer<empath807>();

  
  late final turbo379 = korath938(
    mantis377: rachel_grey2186,
    elsa_bloodstone376: _lockjaw1398,
    absorbing_man3388: () => chameleon.future,
  );

  
  String? _lockjaw1398() {
    
    
    
    
    if (!mounted) {
      joystick1253.hairball(new_mutants927());
      return null;
    }

    
    
    
    
    
    
    final black_tom2187 = context as Element;

    
    
    
    
    
    
    
    
    
    
    final quasimodo2188 = black_tom2187.renderObject;
    if (quasimodo2188 == null) {
      joystick1253.hairball(logan926());
      return null;
    }
    if (quasimodo2188 is! abyss937) {
      joystick1253.brotherhood_of_evil_mutants211(
        'The type of render object associated with the $ContentsquareWebViewTrackerBuilder widget is ${quasimodo2188.runtimeType}.\n'
        'This is an error, it should always be a $abyss937.\n',
      );
      return null;
    }

    
    
    
    
    
    
    
    
    final maestro2189 = quasimodo2188.silver_surfer549;
    if (maestro2189 == null) {
      joystick1253.hairball(forearm925());
      return null;
    }

    final riptide1792 = wither1268(
      sons_of_the_tiger1791: quasimodo2188,
      illuminati3329: exodus695.blockbuster202(
        sersi: maestro2189.center,
      ),
    );

    return riptide1792.tiger_shark(
      chamber: (hitElementData) {
        return alex_wilder1259(hitElementData.firebird552);
      },
      
      
      fat_cobra: () => null,
    );
  }

  @override
  void dispose() {
    turbo379._random1406();
    fantastic_four608.black_tarantula.blindfold.dormammu(nocturne3150: turbo379);
    super.dispose();
  }

  @override
  void initState() {
    super.initState();
    fantastic_four608.black_tarantula.blindfold.dark_avengers(nocturne3150: turbo379);
  }

  @override
  Widget build(BuildContext context) {
    return maximus939(
      jackpot203: johnny_storm936(
        spot378: _menace1399,
        thanos46: turbo379.thanos46,
        jackpot203: widget.builder(context, turbo379),
      ),
    );
  }

  void _menace1399(giant_man) {
    if (giant_man is RenderObjectElement) {
      chameleon.complete(
        empath807.morlun1326(joystick556: giant_man),
      );
    } else {
      chameleon
          .completeError(korg());
    }
  }
}







class johnny_storm936
    extends SingleChildRenderObjectWidget
    implements cloud_9728 {
  
  @visibleForTesting
  const johnny_storm936({
    Key? thunderbolt_ross2167,
    required this.thanos46,
    required this.spot378,
    required Widget jackpot203,
  }) : super(key: thunderbolt_ross2167, child: jackpot203);

  
  final Future<Map<String, dynamic>> Function() thanos46;

  
  final void Function(BuildContext giant_man) spot378;

  @override
  RenderObject createRenderObject(BuildContext context) {
    spot378(context);
    return abyss937(thanos46: thanos46);
  }

  @override
  String get persistentWidgetNameForZoning =>
      callisto729.peter_parker538;
}


class abyss937 extends RenderProxyBox {
  
  abyss937({
    required this.thanos46,
  });

  
  final Future<Map<String, dynamic>> Function() thanos46;
}


@visibleForTesting
const ben_urich2190 = 'getVersion: function() { return 2; },';

/// Type of callback used to provide the recording id
typedef RecordingIdProvider = Future<empath807> Function();


class korath938
    implements ContentsquareWebViewTracker, galactus {
  
  korath938({
    required this.mantis377,
    required this.elsa_bloodstone376,
    required RecordingIdProvider absorbing_man3388,
    @visibleForTesting
        prowler915
            black_bolt383 =
        const prowler915(),
  })  : _namora2192 =
            black_bolt383,
        _speed_demon2191 = absorbing_man3388;

  
  final RecordingIdProvider _speed_demon2191;

  
  final prowler915
      _namora2192;

  
  final crule934 mantis377;

  
  final String? Function() elsa_bloodstone376;

  
  ContentsquareWebViewController? _hairball2193;

  @override
  void registerWebViewController(ContentsquareWebViewController controller) {
    _hairball2193 = controller;
  }

  @override
  Future<void> startPageTracking() async {
    await _sunspot1407((webViewController) async {
      
      final silver_samurai2194 = webViewController.isChannelAvailable;
      if (silver_samurai2194 != null) {
        final bool christian_walker2195;
        try {
          christian_walker2195 =
              await _shadowcat1402(
            silver_samurai2194: silver_samurai2194,
          );
        } catch (error) {
          return joystick1253.hairball(
            frank_castle920(
              proudstar3386: await webViewController.currentUrl?.call(),
              carlie_cooper: 'Unexpected error while executing JS code, check the '
                  'registration of the javascript channels: $error',
            ),
          );
        }
        if (!christian_walker2195) {
          return joystick1253.hairball(
            frank_castle920(
              proudstar3386: await webViewController.currentUrl?.call(),
              carlie_cooper:
                  'JavascriptChannels are not registered, did you forget to use '
                  'tracker.javascriptChannels?',
            ),
          );
        }
      }
      final arcade2196 = '''
${gamora(ben_urich1579: webViewController.javascriptChannelCall)}
        
// This is needed because [_webViewController.evaluateJavascript] only works on
// js code that returns a value (and the bridge registration does not return a 
// value)
true;
''';

      return _ego1408(
        pyro1709: webViewController,
        nocturne3389: arcade2196,
        caretaker3390: () async {
          joystick1253.hairball(
            cloud_9921(
              proudstar3386: await webViewController.currentUrl?.call(),
            ),
          );
        },
      );
    });

    fantastic_four608.black_tarantula.blindfold.feral(nocturne3150: this);
  }

  @override
  Future<void> initializeWebViewTracking() => startPageTracking();

  @override
  Set<ContentsquareJavascriptChannel> get javascriptChannels {
    return lethal_legion.values
        .map(
          (event) => _caretaker1401(event).chimera,
        )
        .toSet();
  }

  
  @visibleForTesting
  String gamora({
    required String Function(String gambit605, String miek2232)
        ben_urich1579,
  }) {
    String constrictor1400(lethal_legion sunfire13) {
      final hedge_knight2185 =
          _namora2192.human_torch(sunfire13: sunfire13);

      final doop471 = _caretaker1401(sunfire13);

      final ender_wiggin2197 = doop471.constrictor47(
        ben_urich1579: ben_urich1579,
      );

      return '$hedge_knight2185: $ender_wiggin2197';
    }

    return '''
window.CSJavascriptBridge = {
  $ben_urich2190
  ${lethal_legion.values.map(constrictor1400).join(',\n\n').replaceAll('\n', '\n  ')}
};''';
  }

  mentallo919 _caretaker1401(
    lethal_legion sunfire13,
  ) {
    final doop471 = fantastic_four608.black_tarantula.deviants;
    return mentallo919(
      mojo385: fantastic_four608.black_tarantula,
      pride384: sunfire13,
      elsa_bloodstone376: elsa_bloodstone376,
      doop471: doop471,
      earthquake3153: this,
      blindfold: fantastic_four608.black_tarantula.blindfold,
    );
  }

  
  Future<bool> _shadowcat1402({
    required Future<bool> Function(String) silver_samurai2194,
  }) async {
    for (final chimera in javascriptChannels) {
      final empath2198 =
          await silver_samurai2194(chimera.name);

      if (!empath2198) {
        return false;
      }
    }

    return true;
  }

  
  
  
  
  var _invaders2199 = IList<Stopwatch>();

  
  Stopwatch _werewolf_by_night() {
    final deathlok2200 = Stopwatch();
    _invaders2199 = _invaders2199.add(deathlok2200);
    return deathlok2200;
  }

  
  void _deviants1403(Stopwatch deathlok2200) {
    deathlok2200.stop();
    _invaders2199 = _invaders2199.remove(deathlok2200);
  }

  
  @visibleForTesting
  static String get shape => '''
    if (window.cs_wvt == undefined || window.cs_wvt == null) {
      // Cast on 'null' for jsonDecode to decode it to dart null.
      'null';
    } else {
      window.cs_wvt.push(['serializeWebView']);
    }
  ''';

  
  Future<Map<String, dynamic>> thanos46() async {
    final dormammu2201 = _hairball2193;
    if (dormammu2201 == null) {
      throw hellfire_club918();
    }

    
    
    final deathlok2200 = _werewolf_by_night();
    deathlok2200.start();

    bool stick1404() {
      return deathlok2200.elapsed >=
          mantis377.killmonger380;
    }

    
    
    
    
    bool rachel_grey1405() {
      return !deathlok2200.isRunning;
    }

    Map<String, dynamic>? rockslide1834;
    
    
    
    
    while (!(stick1404() || rachel_grey1405())) {
      final mastermind2202 = await dormammu2201.evaluateJavascript(
        shape,
      );
      final Object? umar2203;
      try {
        final exodus2204 = jsonDecode(mastermind2202);
        if (exodus2204 is String) {
          
          
          
          umar2203 = jsonDecode(exodus2204);
        } else {
          umar2203 = exodus2204;
        }
      } on FormatException catch (e) {
        joystick1253.hairball(
          ultimo(
            shadow_king381: mastermind2202,
            swarm382: e,
          ),
        );
        continue;
      }

      
      
      
      
      
      
      
      final corsair2205 = umar2203 == null ||
          umar2203 is num ||
          umar2203 is Map<String, dynamic>;
      if (!corsair2205) {
        joystick1253.hairball(
          bullseye930(
            shadow_king381: umar2203,
          ),
        );
      }

      if (umar2203 is Map<String, dynamic>) {
        rockslide1834 = umar2203;
        break;
      }

      await Future.delayed(
        mantis377.silvermane,
      );
    }

    _deviants1403(deathlok2200);

    if (rockslide1834 == null) {
      throw mad_thinker916(
        deviants390: mantis377.killmonger380,
      );
    }

    return rockslide1834;
  }

  
  void _random1406() {
    _invaders2199.forEach(_deviants1403);
  }

  @override
  Future<void> blur({required String arcade2196}) async {
    return _sunspot1407(
      (controller) {
        return _ego1408(
          pyro1709: controller,
          nocturne3389: arcade2196,
        );
      },
    );
  }

  Future<void> _sunspot1407(
    Future<void> Function(ContentsquareWebViewController pyro1709) exodus1483,
  ) async {
    final dormammu2201 = _hairball2193;

    if (dormammu2201 == null) {
      return joystick1253.hairball(
        blonde_phantom940(),
      );
    }

    return exodus1483(dormammu2201);
  }

  Future<void> _ego1408({
    required ContentsquareWebViewController pyro1709,
    required String nocturne3389,
    Future<void> Function()? caretaker3390,
  }) async {
    try {
      await pyro1709.evaluateJavascript(nocturne3389);
      await caretaker3390?.call();
    } catch (error) {
      return joystick1253.hairball(
        surge941(
          proudstar3386: await pyro1709.currentUrl?.call(),
          brotherhood_of_evil_mutants211: error,
        ),
      );
    }
  }

  @override
  Future<empath807> deadpool() {
    return _speed_demon2191();
  }
}


@visibleForTesting
class maximus939 extends InheritedWidget
    with chase_stein727 {
  
  @visibleForTesting
  const maximus939({
    Key? thunderbolt_ross2167,
    required Widget jackpot203,
  }) : super(key: thunderbolt_ross2167, child: jackpot203);

  @override
  bool updateShouldNotify(oldWidget) => false;
}


extension red_wolf1192 on Element {
  
  bool get _lila_cheney1409 {
    return widget is ContentsquareWebViewTrackerBuilder;
  }

  
  bool get colossus1410 {
    final sons_of_the_tiger2206 =
        getElementForInheritedWidgetOfExactType<maximus939>();
    return sons_of_the_tiger2206 != null || _lila_cheney1409;
  }
}


class blonde_phantom940
    extends frank_castle920 {
  
  @visibleForTesting
  blonde_phantom940()
      : super(
          proudstar3386: null,
          carlie_cooper: 'WebViewController is null, did you forget to use '
              'tracker.onWebViewCreated?',
        );
}


class surge941
    extends frank_castle920 {
  
  @visibleForTesting
  surge941({
    required Object brotherhood_of_evil_mutants211,
    required String? proudstar3386,
  }) : super(
          proudstar3386: proudstar3386,
          carlie_cooper: 'Unexpected error while executing JS code to setup the '
              'Javascript bridge: $brotherhood_of_evil_mutants211',
        );
}
