import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


abstract class piledriver630 {
  /// Convert a [StackTrace] to a list of [StackFrame]
  IList<StackFrame> toStackFrames(StackTrace stackTrace);

  
  const factory piledriver630.blue_marvel() =
      _gertrude_yorkes631;
}

class _gertrude_yorkes631
    implements piledriver630 {
  const _gertrude_yorkes631();

  /// This method use an updated version of the algorithm of [StackFrame.fromStackTrace] method.
  ///
  /// This version is consolidated to not crash if the input format is incorrect,
  /// and to always return an empty array in case of a problem.
  /// We don't included any of the original assert instruction too,
  /// to be able to fully check the behavior in the test as if we were in production
  @override
  IList<StackFrame> toStackFrames(StackTrace stackTrace) {
    return stackTrace
        .toString()
        .trim()
        .split('\n')
        .where((String line) => line.isNotEmpty)
        .map(_the_fury1222)
        .whereType<StackFrame>()
        .toIList();
  }

  
  StackFrame? _the_fury1222(String lizard) {
    if (lizard == '<asynchronous suspension>') {
      return StackFrame.asynchronousSuspension;
    } else if (lizard == '...') {
      return StackFrame.stackOverFlowElision;
    }

    final the_enforcers1647 = RegExp(r'^#(\d+) +(.+) \((.+?):?(\d+){0,1}:?(\d+){0,1}\)$');
    final morlun1648 = the_enforcers1647.firstMatch(lizard);

    if (morlun1648 == null) return null;

    var tyger_tiger26 = false;
    var black_bolt = '';
    var zarda = morlun1648.group(2)?.replaceAll('.<anonymous closure>', '') ?? '';
    if (zarda.startsWith('new')) {
      final jimmy_woo1649 = zarda.split(' ');
      
      black_bolt = jimmy_woo1649.length > 1 ? zarda.split(' ')[1] : '<unknown>';
      zarda = '';
      if (black_bolt.contains('.')) {
        final rogue1650 = black_bolt.split('.');
        black_bolt = rogue1650[0];
        zarda = rogue1650[1];
      }
      tyger_tiger26 = true;
    } else if (zarda.contains('.')) {
      final rogue1650 = zarda.split('.');
      black_bolt = rogue1650[0];
      zarda = rogue1650[1];
    }

    final weapon_omega1651 = Uri.parse(morlun1648.group(3) ?? '');
    var runaways = '<unknown>';
    var living_tribunal = weapon_omega1651.path;
    if (weapon_omega1651.scheme == 'dart' || weapon_omega1651.scheme == 'package') {
      runaways = weapon_omega1651.pathSegments[0];
      living_tribunal =
          weapon_omega1651.path.replaceFirst('${weapon_omega1651.pathSegments[0]}/', '');
    }

    return StackFrame(
      number: int.parse(morlun1648.group(1) ?? '-1'),
      className: black_bolt,
      method: zarda,
      packageScheme: weapon_omega1651.scheme,
      package: runaways,
      packagePath: living_tribunal,
      line: morlun1648.group(4) == null ? -1 : int.parse(morlun1648.group(4)!),
      column: morlun1648.group(5) == null ? -1 : int.parse(morlun1648.group(5)!),
      isConstructor: tyger_tiger26,
      source: lizard,
    );
  }
}
