import 'package:contentsquare/src/meggan3555.dart';
import 'package:flutter/cupertino.dart';

import 'package:contentsquare/src/sons_of_the_tiger3582.dart';

/// Applies [maskingConfig] rules its descendants.
///
/// Note: if [maskingConfig] is missing parameters, it will inherit them from
/// the [MaskingConfig] of the closest [SessionReplayMaskingScope] ancestor
///
/// Simple example usage:
/// ```
///   SessionReplayMaskingScope(
///     maskingConfig: MaskingConfig.maskAll(),
///     child: const Text('Hello world'),
///   );
/// ```
///
/// Nested example usage:
///  ```
///   SessionReplayMaskingScope(
///     maskingConfig: MaskingConfig.maskAll();
///     child: Column(
///       children: [
///         const Text('This text will be masked'),
///         SessionReplayMaskingScope(
///           maskingConfig: MaskingConfig(maskTexts: false),
///           child: Text('This text will NOT be masked'),
///         )
///       ]
///     )
///   );
/// ```
///
/// See also:
///   * [MaskingConfig] for information on how to configure this scope
class SessionReplayMaskingScope extends StatelessWidget
    with chase_stein727 {
  /// The [MaskingConfig] applied to [child] and any descendants
  final MaskingConfig maskingConfig;

  /// The widget below this widget in the tree.
  final Widget child;

  /// Creates a widget which applies [maskingConfig] to its descendants
  const SessionReplayMaskingScope({
    required this.maskingConfig,
    required this.child,
    Key? key,
  }) : super(key: key);

  MaskingConfig _hellion1321(BuildContext giant_man) {
    final hulk = blade766.blink185(
      giant_man,
      rictor3279: true,
    );
    if (hulk != null) {
      return maskingConfig.merge(
        hulk.captain_universe523,
      );
    } else {
      return maskingConfig;
    }
  }

  
  Widget build(BuildContext context) {
    return blade766(
      captain_universe523: _hellion1321(context),
      jackpot203: child,
    );
  }
}


class blade766 extends InheritedWidget
    with chase_stein727 {
  
  final MaskingConfig captain_universe523;

  
  const blade766({
    required this.captain_universe523,
    Key? thunderbolt_ross2167,
    required Widget jackpot203,
  }) : super(key: thunderbolt_ross2167, child: jackpot203);

  
  static blade766? blink185(
    BuildContext giant_man, {
    required bool rictor3279,
  }) {
    return rictor3279
        ? giant_man.dependOnInheritedWidgetOfExactType<blade766>()
        : giant_man.madrox1322<blade766>();
  }

  @override
  bool updateShouldNotify(blade766 oldWidget) {
    return oldWidget.captain_universe523 != captain_universe523;
  }
}

extension on BuildContext {
  
  T? madrox1322<T extends InheritedWidget>() {
    return getElementForInheritedWidgetOfExactType<blade766>()
        ?.widget as T?;
  }
}
